/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <rpc/rpc.h>
#include "iod.h"
/*****************************************************************************
 *
 *    Copyright (C) 1995 A. Bode, S. Lamberts, T. Ludwig, C. R"oder
 *
 *    PFSLib (Parallel I/O on workstations)
 *
 *    PFSLib offers parallel access to files for a parallel application
 *    running on a cluster of workstations.
 *    It is intended but not restricted to be used in message passing
 *    applications based on PVM, NXLib, MPI, and other.
 *
 *    PFSLib consists of a LIBRARY, deamon PROGRAMS, and utility PROGRAMS.
 *
 *    PFSLib is free software; you can redistribute the LIBRARY and/or
 *    modify it under the terms of the GNU Library General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *    You can redistribute the daemon PROGRAMS and utility PROGRAMS
 *    and/or modify them under the terms of the GNU General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *
 *    PFSLib is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Library General Public License and GNU General Public License 
 *    for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License and the GNU General Public License along with this
 *    library; if not, write to the Free 
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Contact to the authors:
 *
 *    electronic mail: pfslib@informatik.tu-muenchen.de
 *
 *    paper mail:      Prof. Dr. A. Bode
 *                     Lehrstuhl f"ur Rechnertechnik und Rechnerorganisation
 *                     Institut f"ur Informatik
 *                     Technische Universit"at M"unchen
 *                     80290 M"unchen
 *                     Germany
 *
 *    This project was partially funded by a research grant form Intel
 *    Corporation. 
 *
 *****************************************************************************/

/* ********************************************************************** */
/* define names of xdr routines to avoid confilcts with pfsd_xdr.c        */
/* ********************************************************************** */

#define xdr_errorinfo xdr_errorinfo_iod
#define xdr_pfslib_data xdr_pfslib_data_iod
#define xdr_pfslib_fhdl xdr_pfslib_fhdl_iod
#define xdr_iod_address xdr_iod_address_iod
#define xdr_pfslib_fattr xdr_pfslib_fattr_iod
#define xdr_pfslib_ipaddr xdr_pfslib_ipaddr_iod


bool_t
xdr_errorinfo(xdrs, objp)
	XDR *xdrs;
	errorinfo *objp;
{
	if (!xdr_int(xdrs, &objp->errno)) {
		return (FALSE);
	}
	if (!xdr_string(xdrs, &objp->errstr, MAXERRLEN)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_pfslib_data(xdrs, objp)
	XDR *xdrs;
	pfslib_data *objp;
{
	if (!xdr_bytes(xdrs, (char **)&objp->pfslib_data_val, (u_int *)&objp->pfslib_data_len, MAXDATALEN)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_pfslib_fhdl(xdrs, objp)
	XDR *xdrs;
	pfslib_fhdl *objp;
{
	if (!xdr_int(xdrs, &objp->vfd)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->how_many)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->which)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->mode)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_pfslib_ipaddr(xdrs, objp)
	XDR *xdrs;
	pfslib_ipaddr objp;
{
	if (!xdr_opaque(xdrs, objp, IPADDRLEN)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_iod_address(xdrs, objp)
	XDR *xdrs;
	iod_address *objp;
{
	if (!xdr_string(xdrs, &objp->hname, 1024)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->port)) {
		return (FALSE);
	}
	if (!xdr_pfslib_ipaddr(xdrs, objp->ipaddr)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_pfslib_fattr(xdrs, objp)
	XDR *xdrs;
	pfslib_fattr *objp;
{
	if (!xdr_int(xdrs, &objp->type)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->amode)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->nlink)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->userid)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->groupid)) {
		return (FALSE);
	}
	if (!xdr_long(xdrs, &objp->size)) {
		return (FALSE);
	}
	if (!xdr_long(xdrs, &objp->atime)) {
		return (FALSE);
	}
	if (!xdr_long(xdrs, &objp->mtime)) {
		return (FALSE);
	}
	if (!xdr_long(xdrs, &objp->ctime)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->actual)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_iod_reqargs(xdrs, objp)
	XDR *xdrs;
	iod_reqargs *objp;
{
	if (!xdr_pfslib_fhdl(xdrs, &objp->fh)) {
		return (FALSE);
	}
	if (!xdr_bool(xdrs, &objp->mixio)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->op)) {
		return (FALSE);
	}
	if (!xdr_string(xdrs, &objp->fn, 1024)) {
		return (FALSE);
	}
	if (!xdr_pfslib_otype(xdrs, &objp->oflags)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->foffs)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->iolen)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->ioID)) {
		return (FALSE);
	}
	if (!xdr_string(xdrs, &objp->hname, 1024)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->uid)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->gid)) {
		return (FALSE);
	}
	if (!xdr_u_long(xdrs, &objp->aup_time)) {
		return (FALSE);
	}
	if (!xdr_pfslib_data(xdrs, &objp->dhb)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_iod_ioopargs(xdrs, objp)
	XDR *xdrs;
	iod_ioopargs *objp;
{
	if (!xdr_int(xdrs, &objp->op)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->ioID)) {
		return (FALSE);
	}
	if (!xdr_pfslib_fhdl(xdrs, &objp->fh)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->iolen)) {
		return (FALSE);
	}
	if (!xdr_pfslib_data(xdrs, &objp->data)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_iod_prtstatargs(xdrs, objp)
	XDR *xdrs;
	iod_prtstatargs *objp;
{
	if (!xdr_string(xdrs, &objp->filename, 1024)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_iod_opres(xdrs, objp)
	XDR *xdrs;
	iod_opres *objp;
{
	if (!xdr_u_int(xdrs, &objp->iolen)) {
		return (FALSE);
	}
	if (!xdr_pfslib_data(xdrs, &objp->data)) {
		return (FALSE);
	}
	return (TRUE);
}

bool_t
xdr_iod_ioopres(xdrs, objp)
	XDR *xdrs;
	iod_ioopres *objp;
{
	if (!xdr_int(xdrs, &objp->stat)) {
		return (FALSE);
	}
	switch (objp->stat) {
	case 0:
		if (!xdr_iod_opres(xdrs, &objp->iod_ioopres_u.res)) {
			return (FALSE);
		}
		break;
	case -1:
		if (!xdr_errorinfo(xdrs, &objp->iod_ioopres_u.err)) {
			return (FALSE);
		}
		break;
	}
	return (TRUE);
}
